Invalid Certificates need better handling
Description

Some stupid people in my enterprise have got strange ideas on what an FQDN is...

They have managed to create hosts with certificate names like ".stsn.com" and ".ibahn.com" - of course, when Foreman tries to
parse that, it gets nil for the hostname. We need to handle that better so that the Certificate Management page doesn't blow up when
trying to render it.

Interestingly, if you revoke (but not clean) the offending cert, Foreman displayed the revoked certificate just fine.

History

#1 - 12/20/2011 06:54 AM - Ohad Levy

to me it sounds like a problem in the proxy rather in foreman, can you look at the json output the proxy is responding to figure out any possible
reasons?

#2 - 01/15/2012 10:33 AM - Ohad Levy
- Status changed from New to Need more information

- Assignee set to Greg Sutcliffe

#3 - 01/27/2012 12:24 PM - Greg Sutcliffe

I'm massively out of practice after a month away, clearly. I'll have a poke about in the proxy soon, | hope :)

#4 - 02/09/2012 08:09 AM - Greg Sutcliffe

Ok, so the proxy output completes without error, and looks sane (well, as sane as possible in these situations). Running:

curl http://localhost:8443/puppet/ca

gets me all the certificates, and | can see this:
".office.etvinteractive.com":{"state":"revoked","serial":282,"not_before":"2011-10-27T10:05:00GMT","not_after":"2016-10-25T10:05:00GMT"}
in the output. The actual error message on the Foreman Ul is:

smart_proxy_puppetca_url failed to generate from {:smart_proxy_id=>"1-local", :action=>"update", :controller=>"SmartProxies::Puppetca”,
sid=>#<SmartProxies::PuppetCA:0xb563b130 @expires_at=nil, @valid_from=nil, @fingerprint="4E:4C:13:3B:D0:69:41:57:54:CE:66:5E:66:E6:58:44",
@name=".office.etvinteractive.com", @smart_proxy_id=1, @state="pending">}, expected: {:action=>"update",
:controller=>"SmartProxies::Puppetca"}, diff: {:smart_proxy_id=>"1-local", :id=>#<SmartProxies::PuppetCA:0xb563b130 @expires_at=nil,
@valid_from=nil, @fingerprint="4E:4C:13:3B:D0:69:41:57:54:CE:66:5E:66:E6:58:44", @name=".office.etvinteractive.com", @smart_proxy_id=1,
@state="pending">}

with a trace of:

smart_proxy_puppetca_url failed to generate from {:smart_proxy_id=>"1-local", :action=>"update", :controller=>"SmartProxies::Puppetca", :id=>#},
expected: {:action=>"update", :controller=>"SmartProxies::Puppetca"}, diff: {:smart_proxy_id=>"1-local", :id=>#}
app/helpers/application_helper.rb:105:in “display_link_if_authorized'

app/views/smart_proxies/puppetca/index.html.erb:22

app/views/smart_proxies/puppetca/index.html.erb:14:in “each’

app/views/smart_proxies/puppetca/index.html.erb:14
http://localhost:8443/puppet/ca

I'm wondering if this is to do with the space-handling patch we merged in a while back - | can see spaced output coming from the proxy, eg:
"grove.etvinteractive.com "{"fingerprint":"41:4A:F3:E7:F8:3A:5E:FB:A9:4F:20:93:A3:A3:7B:AD","state":"valid"}

I'm going to see what happens if | move the whitespace handling code to the proxy, so that the duplicate-certname bug can be resolved as well - |
suspect these two are related somehow...

#5 - 05/15/2012 09:26 AM - Greg Sutcliffe
- Status changed from Need more information to Closed

- % Done changed from 0 to 100

I don't think this applies any more, so I'm closing it. If | see it again, I'll re-open.

05/12/2024 22


http://www.tcpdf.org

